/** 
 * FormValidation (https://formvalidation.io)
 * The best validation library for JavaScript
 * (c) 2013 - 2023 Nguyen Huu Phuoc <me@phuoc.ng>
 *
 * @license https://formvalidation.io/license
 * @package plugin-mandatory-icon
 * @version 2.0.0
 */

define(["exports","@form-validation/core"],(function(e,t){"use strict";var n=function(e,t){return n=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)Object.prototype.hasOwnProperty.call(t,n)&&(e[n]=t[n])},n(e,t)};var i=t.utils.classSet,o=function(e){function t(t){var n=e.call(this,t)||this;return n.removedIcons={Invalid:"",NotValidated:"",Valid:"",Validating:""},n.icons=new Map,n.elementValidatingHandler=n.onElementValidating.bind(n),n.elementValidatedHandler=n.onElementValidated.bind(n),n.elementNotValidatedHandler=n.onElementNotValidated.bind(n),n.iconPlacedHandler=n.onIconPlaced.bind(n),n.iconSetHandler=n.onIconSet.bind(n),n}return function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function i(){this.constructor=e}n(e,t),e.prototype=null===t?Object.create(t):(i.prototype=t.prototype,new i)}(t,e),t.prototype.install=function(){this.core.on("core.element.validating",this.elementValidatingHandler).on("core.element.validated",this.elementValidatedHandler).on("core.element.notvalidated",this.elementNotValidatedHandler).on("plugins.icon.placed",this.iconPlacedHandler).on("plugins.icon.set",this.iconSetHandler)},t.prototype.uninstall=function(){this.icons.clear(),this.core.off("core.element.validating",this.elementValidatingHandler).off("core.element.validated",this.elementValidatedHandler).off("core.element.notvalidated",this.elementNotValidatedHandler).off("plugins.icon.placed",this.iconPlacedHandler).off("plugins.icon.set",this.iconSetHandler)},t.prototype.onIconPlaced=function(e){var t,n=this,o=this.core.getFields()[e.field].validators,a=this.core.getElements(e.field);if(o&&o.notEmpty&&!1!==o.notEmpty.enabled&&a.length){this.icons.set(e.element,e.iconElement);for(var l=a[0].getAttribute("type"),s=l?l.toLowerCase():"",d=0,c="checkbox"===s||"radio"===s?[a[0]]:a;d<c.length;d++){var r=c[d];""===this.core.getElementValue(e.field,r)&&i(e.iconElement,((t={})[this.opts.icon]=!0,t))}}this.iconClasses=e.classes;var p=this.opts.icon.split(" "),h={Invalid:this.iconClasses.invalid?this.iconClasses.invalid.split(" "):[],Valid:this.iconClasses.valid?this.iconClasses.valid.split(" "):[],Validating:this.iconClasses.validating?this.iconClasses.validating.split(" "):[]};Object.keys(h).forEach((function(e){for(var t=[],i=0,o=p;i<o.length;i++){var a=o[i];-1===h[e].indexOf(a)&&t.push(a)}n.removedIcons[e]=t.join(" ")}))},t.prototype.onElementValidating=function(e){this.updateIconClasses(e.element,"Validating")},t.prototype.onElementValidated=function(e){this.updateIconClasses(e.element,e.valid?"Valid":"Invalid")},t.prototype.onElementNotValidated=function(e){this.updateIconClasses(e.element,"NotValidated")},t.prototype.updateIconClasses=function(e,t){var n,o=this.icons.get(e);o&&this.iconClasses&&(this.iconClasses.valid||this.iconClasses.invalid||this.iconClasses.validating)&&i(o,((n={})[this.removedIcons[t]]=!1,n[this.opts.icon]=!1,n))},t.prototype.onIconSet=function(e){var t,n=this.icons.get(e.element);n&&("NotValidated"===e.status&&""===this.core.getElementValue(e.field,e.element)||"Ignored"===e.status)&&i(n,((t={})[this.opts.icon]=!0,t))},t}(t.Plugin);e.MandatoryIcon=o}));
